Overview | Package | Class | Tree | Deprecated | Index | Help
| Oracle Application Development Framework Model and Business Components Java API Reference 10g Release 3 (10.1.3) B16005-01
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## oracle.jbo.server.java.util
Class AbstractList

`java.lang.Object
oracle.jbo.server.java.util.AbstractCollection
oracle.jbo.server.java.util.AbstractList`

All Implemented Interfaces:
  Collection, List

Direct Known Subclasses:
  AbstractSequentialList, ArrayList

public abstract class AbstractList
extends AbstractCollection
implements List

This class provides a skeletal implementation of the List interface to minimize the effort required to implement this interface backed by a "random access" data store (such as an array). For sequential access data (such as a linked list), AbstractSequentialList should be used in preference to this Class.

To implement an unmodifiable List, the programmer needs only to extend this class and provide implementations for the get(int index) and size() methods.

To implement a modifiable List, the programmer must additionally override the set(int index, Object element) method (which otherwise throws an UnsupportedOperationException. If the List is variable-size the programmer must additionally override the add(int index, Object element) and remove(int index) methods.

The programmer should generally provide a void (no argument) and Collection constructor, as per the recommendation in the Collection interface specification.

Unlike the other abstract Collection implementations, the programmer does not have to provide an Iterator implementation; the iterator and listIterator are implemented by this class, on top the "random access" methods: get(int index), set(int index, Object element), set(int index, Object element), add(int index, Object element) and remove(int index).

The documentation for each non-abstract methods in this class describes its implementation in detail. Each of these methods may be overridden if the Collection being implemented admits a more efficient implementation.

Since:
  JDK1.2
See Also:
  `Collection`, `List`, `AbstractSequentialList`, `AbstractCollection`

Field Summary
`protected int` | `modCount` The number of times this List has been structurally modified.

Constructor Summary
`AbstractList()`

Method Summary
`void` | `add(int index, java.lang.Object element)` Inserts the specified element at the specified position in this List (optional operation).
`boolean` | `add(java.lang.Object o)` Appends the specified element to the end of this List (optional operation).
`boolean` | `addAll(int index, Collection c)` Inserts all of the elements in in the specified Collection into this List at the specified position (optional operation).
`boolean` | `equals(java.lang.Object o)` Compares the specified Object with this List for equality.
`abstract java.lang.Object` | `get(int index)` Returns the element at the specified position in this List.
`int` | `indexOf(java.lang.Object o)` Returns the index in this List of the first occurence of the specified element, or -1 if the List does not contain this element.
`int` | `indexOf(java.lang.Object o, int index)` Returns the index in this List of the first occurence of the specified element at or after the specified position, or -1 if the element is not found.
`Iterator` | `iterator()` Returns an Iterator over the elements in this List in proper sequence.
`int` | `lastIndexOf(java.lang.Object o)` Returns the index in this List of the last occurence of the specified element, or -1 if the List does not contain this element.
`int` | `lastIndexOf(java.lang.Object o, int index)` Returns the index in this List of the last occurence of the specified element at or before the specified position, or -1 if the List does not contain this element.
`ListIterator` | `listIterator()` Returns an Iterator of the elements in this List (in proper sequence).
`ListIterator` | `listIterator(int index)` Returns a ListIterator of the elements in this List (in proper sequence), starting at the specified position in the List.
`java.lang.Object` | `remove(int index)` Removes the element at the specified position in this List (optional operation).
`void` | `removeRange(int fromIndex, int toIndex)` Removes from this List all of the elements whose index is between fromIndex, inclusive and toIndex, exclusive (optional operation).
`java.lang.Object` | `set(int index, java.lang.Object element)` Replaces the element at the specified position in this List with the specified element (optional operation).

Methods inherited from class oracle.jbo.server.java.util.AbstractCollection
`addAll, clear, contains, containsAll, isEmpty, remove, removeAll, retainAll, size, toArray, toString`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Methods inherited from interface oracle.jbo.server.java.util.List
`addAll, clear, contains, containsAll, hashCode, isEmpty, remove, removeAll, retainAll, size, toArray`

Field Detail

### modCount

    protected transient int modCount

  The number of times this List has been structurally modified. Structural modifications are those that change the size of the List, or otherwise perturb it in such a fashion that iterations in progress may yield incorrect results.

  This field is used by the the Iterator and ListIterator implementation returned by the iterator and listIterator methods. If the value of this field changes unexpectedly, the Iterator (or ListIterator) will throw a ConcurrentModificationDetected exception in response to the next, remove, previous, set or add operations. This provides fail-fast behavior, rather than non-deterministic behavior in the face of concurrent modification during iteration.

  Use of this field by subclasses is optional. If a subclass wishses to provide fail-fast Iterators (and ListIterators), then it merely has to increment this field in its add(int, Object) and remove(int) methods (and any other methods that it overrides that result in structural modifications to the List). If an implementation does not wish to provide fail-fast Iterators, this field may be ignored.

  Since:
    JDK1.2

Constructor Detail

### AbstractList

    public AbstractList()

Method Detail

### add

    public boolean add(java.lang.Object o)

  Appends the specified element to the end of this List (optional operation).

  This implementation calls `add(size(), o)`.

  Note that this implementation will throw an UnsupportedOperationException unless add(int, Object) is overridden.

  Specified by:
    `add` in interface `List`
  Overrides:
    `add` in class `AbstractCollection`
  Parameters:
    `o` - element to be appended to this List.
  Returns:
    true (as per the general contract of Collection.add).
  Throws:
    `UnsupportedOperationException` - add is not supported by this Set.
    `java.lang.ClassCastException` - class of the specified element prevents it from being added to this Set.
    `java.lang.IllegalArgumentException` - some aspect of this element prevents it from being added to this Collection.
  Since:
    JDK1.2

### get

    public abstract java.lang.Object get(int index)

  Returns the element at the specified position in this List.
  Specified by:
    `get` in interface `List`
  Parameters:
    `index` - index of element to return.
  Throws:
    `java.lang.ArrayIndexOutOfBoundsException` - index is out of range (index < 0 || index >= size()).
  Since:
    JDK1.2

### set

    public java.lang.Object set(int index,
                                java.lang.Object element)

  Replaces the element at the specified position in this List with the specified element (optional operation).

  This implementation always throws an UnsupportedOperationException.

  Specified by:
    `set` in interface `List`
  Parameters:
    `index` - index of element to replace.
    `element` - element to be stored at the specified position.
  Returns:
    the element previously at the specified position.
  Throws:
    `UnsupportedOperationException` - set is not supported by this List.
    `java.lang.ClassCastException` - class of the specified element prevents it from being added to this List.
    `java.lang.IllegalArgumentException` - some aspect of the specified element prevents it from being added to this List.
    `java.lang.ArrayIndexOutOfBoundsException` - index out of range (index < 0 || index >= size()).
  Since:
    JDK1.2

### add

    public void add(int index,
                    java.lang.Object element)

  Inserts the specified element at the specified position in this List (optional operation). Shifts the element currently at that position (if any) and any subsequent elements to the right (adds one to their indices).

  This implementation always throws an UnsupportedOperationException.

  Specified by:
    `add` in interface `List`
  Parameters:
    `index` - index at which the specified element is to be inserted.
    `element` - element to be inserted.
  Throws:
    `UnsupportedOperationException` - add is not supported by this List.
    `java.lang.ClassCastException` - class of the specified element prevents it from being added to this List.
    `java.lang.IllegalArgumentException` - some aspect of the specified element prevents it from being added to this List.
    `java.lang.ArrayIndexOutOfBoundsException` - index is out of range (index < 0 || index > size()).
  Since:
    JDK1.2

### remove

    public java.lang.Object remove(int index)

  Removes the element at the specified position in this List (optional operation). Shifts any subsequent elements to the left (subtracts one from their indices). Returns the element that was removed from the List.

  This implementation always throws an UnsupportedOperationException.

  Specified by:
    `remove` in interface `List`
  Parameters:
    `index` - the index of the element to removed.
  Returns:
    the element previously at the specified position.
  Throws:
    `UnsupportedOperationException` - remove is not supported by this List.
    `java.lang.ArrayIndexOutOfBoundsException` - index out of range (index < 0 || index >= size()).
  Since:
    JDK1.2

### indexOf

    public int indexOf(java.lang.Object o)

  Returns the index in this List of the first occurence of the specified element, or -1 if the List does not contain this element. More formally, returns the lowest index i such that `(o==null ? get(i)==null : o.equals(get(i)))`, or -1 if there is no such index.

  This implementation returns `indexOf(o, 0)`.

  Specified by:
    `indexOf` in interface `List`
  Parameters:
    `o` - element to search for.
  Since:
    JDK1.2

### indexOf

    public int indexOf(java.lang.Object o,
                       int index)

  Returns the index in this List of the first occurence of the specified element at or after the specified position, or -1 if the element is not found. More formally, returns the lowest index i >= index such that `(o==null ? get(i)==null : o.equals(get(i)))`, or -1 if there is no such index.

  This implementation first gets a ListIterator pointing to the indexed element (with listIterator(index)). Then, it iterates over the remainder of the List until the specified element is found or the end of the List is reached.

  Specified by:
    `indexOf` in interface `List`
  Parameters:
    `o` - element to search for.
    `index` - initial position to search for the specified element.
  Throws:
    `java.lang.ArrayIndexOutOfBoundsException` - index out of range (index < 0 || index >= size()).
  Since:
    JDK1.2

### lastIndexOf

    public int lastIndexOf(java.lang.Object o)

  Returns the index in this List of the last occurence of the specified element, or -1 if the List does not contain this element. More formally, returns the highest index i such that `(o==null ? get(i)==null : o.equals(get(i)))`, or -1 if there is no such index.

  This implementation returns `lastIndexOf(o, size()-1)`.

  Specified by:
    `lastIndexOf` in interface `List`
  Parameters:
    `o` - element to search for.
  Since:
    JDK1.2

### lastIndexOf

    public int lastIndexOf(java.lang.Object o,
                           int index)

  Returns the index in this List of the last occurence of the specified element at or before the specified position, or -1 if the List does not contain this element. More formally, returns the highest index i <= index such that `(o==null ? get(i)==null : o.equals(get(i)))`, or -1 if there is no such index.

  This implementation first gets a ListIterator pointing to the element after the indexed element (with listIterator(index)). Then, it iterates backwards over the list until the specified element is found, or the beginning of the list is reached.

  Specified by:
    `lastIndexOf` in interface `List`
  Parameters:
    `o` - element to search for.
    `index` - initial position to search for the specified element.
  Throws:
    `java.lang.ArrayIndexOutOfBoundsException` - index out of range (index < 0 || index >= size()).
  Since:
    JDK1.2

### removeRange

    public void removeRange(int fromIndex,
                            int toIndex)

  Removes from this List all of the elements whose index is between fromIndex, inclusive and toIndex, exclusive (optional operation). Shifts any succeeding elements to the left (reduces their index). This call shortens the List by (toIndex - fromIndex) elements. (If toIndex==fromIndex, this operation has no effect.)

  This implementation first checks to see that the indices are in range. Then, it calls remove(fromIndex) repeatedly, toIndex-fromIndex times. Many implementations will override this method for efficiency.

  Note that this implementation will throw an UnsupportedOperationException unless remove(int) is overridden.

  Specified by:
    `removeRange` in interface `List`
  Parameters:
    `fromIndex` - index of first element to be removed.
    `toIndex` - index after last element to be removed.
  Throws:
    `UnsupportedOperationException` - removeRange is not supported by this List.
    `java.lang.ArrayIndexOutOfBoundsException` - fromIndex or toIndex out of range (fromIndex < 0 || fromIndex >= size() || toIndex > size() || toIndex < fromIndex).
  Since:
    JDK1.2

### addAll

    public boolean addAll(int index,
                          Collection c)

  Inserts all of the elements in in the specified Collection into this List at the specified position (optional operation). Shifts the element currently at that position (if any) and any subsequent elements to the right (increases their indices). The new elements will appear in the List in the order that they are returned by the specified Collection's iterator. The behavior of this operation is unspecified if the specified Collection is modified while the operation is in progress. (Note that this will occur if the specified Collection is this List, and it's nonempty.)

  This implementation gets an Iterator over the specified Collection and iterates over it, inserting the elements obtained from the Iterator into this List at the appropriate position, one at a time, using add(int, Object). Many implementations will override this method for efficiency.

  Note that this implementation will throw an UnsupportedOperationException unless add(int, Object) is overridden.

  Specified by:
    `addAll` in interface `List`
  Parameters:
    `index` - index at which to insert first element from the specified collection.
    `c` - elements to be inserted into this List.
  Returns:
    true if this List changed as a result of the call.
  Throws:
    `UnsupportedOperationException` - addAll is not supported by this List.
    `java.lang.ClassCastException` - class of one of elements of the specified Collection prevents it from being added to this List.
    `java.lang.IllegalArgumentException` - some aspect of one of elements of the specified Collection prevents it from being added to this List.
    `java.lang.ArrayIndexOutOfBoundsException` - index out of range (index < 0 || index > size()).
  Since:
    JDK1.2

### iterator

    public Iterator iterator()

  Returns an Iterator over the elements in this List in proper sequence.

  This implementation returns a straightforward implementation of the Iterator interface, relying on the the backing List's size(), get(int), and remove(int) methods.

  Note that the Iterator returned by this method will throw an UnsupportedOperationException in response to its remove method unless the List's remove(int) method is overridden.

  This implementation can be made to throw runtime exceptions in the face of concurrent modification, as described in the specification for the (protected) modCount field.

  Specified by:
    `iterator` in interface `List`
  Specified by:
    `iterator` in class `AbstractCollection`
  Since:
    JDK1.2
  See Also:
    `modCount`

### listIterator

    public ListIterator listIterator()

  Returns an Iterator of the elements in this List (in proper sequence). This implementation returns `listIterator(0)`.
  Specified by:
    `listIterator` in interface `List`
  Since:
    JDK1.2
  See Also:
    `listIterator(int)`

### listIterator

    public ListIterator listIterator(int index)

  Returns a ListIterator of the elements in this List (in proper sequence), starting at the specified position in the List. The specified index indicates the first element that would be returned by an initial call to nextElement. An initial call to previousElement would return the element with the specified index minus one.

  This implementation returns a straightforward implementation of the ListIterator interface that extends the implementation of the Iterator interface returned by iterator(). The ListIterator implementation relies on the the backing List's get(int), set(int, Object), add(int, Object) and remove(int) methods.

  Note that the ListIterator returned by this implementation will throw an UnsupportedOperationException in response to its remove, set and add methods unless the List's remove(int), set(int, Object), and add(int, Object) methods are overridden (respectively).

  This implementation can be made to throw runtime exceptions in the face of concurrent modification, as described in the specification for the (protected) modCount field.

  Specified by:
    `listIterator` in interface `List`
  Parameters:
    `index` - index of first element to be returned from the ListIterator (by a call to getNext).
  Throws:
    `java.lang.ArrayIndexOutOfBoundsException` - index is out of range (index < 0 || index > size()).
  Since:
    JDK1.2
  See Also:
    `modCount`

### equals

    public boolean equals(java.lang.Object o)

  Compares the specified Object with this List for equality. Returns true if and only if the specified Object is also a List, both Lists have the same size, and all corresponding pairs of elements in the two Lists are equal. (Two elements `e1` and `e2` are equal if `(e1==null ? e2==null : e1.equals(e2))`.) In other words, two Lists are defined to be equal if they contain the same elements in the same order.

  This implementation first checks if the specified object is this List. If so, it returns true; if not, it checks if the specified object is a List. If not, it returns false; if so, it iterates over both lists, comparing corresponding pairs of elements. If any comparison returns false, this method returns false. If either Iterator runs out of elements before before the other it returns false (as the Lists are of unequal length); otherwise it returns true when the iterations complete.

  Specified by:
    `equals` in interface `List`
  Parameters:
    `o` - the Object to be compared for equality with this List.
  Returns:
    true if the specified Object is equal to this List.
  Since:
    JDK1.2

Overview | Package | Class | Tree | Deprecated | Index | Help
| Oracle Application Development Framework Model and Business Components Java API Reference 10g Release 3 (10.1.3) B16005-01
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 1997, 2005, Oracle. All rights reserved.